pangomm 2.40.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Pango::Layout Class Reference

A Pango::Layout represents an entire paragraph of text. More...

`#include <pangomm/layout.h>`

Inheritance diagram for Pango::Layout:
[legend]

## Public Member Functions
| Layout (Layout&& src) noexcept
Layout& | operator= (Layout&& src) noexcept
| ~Layout () noexceptoverride
PangoLayout* | gobj ()
| Provides access to the underlying C GObject. More...
const PangoLayout* | gobj () const
| Provides access to the underlying C GObject. More...
PangoLayout* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | update_from_cairo_context (const Cairo::RefPtr< Cairo::Context >& context)
| Updates the private Pango Context of a Pango Layout created with create(const Cairo::RefPtr<Cairo::Context>&) to match the current transformation and target surface of a Cairo Context. More...
Glib::RefPtr< Layout > | copy ()
| Does a deep copy-by-value of the src layout. More...
Glib::RefPtr< Context > | get_context () const
| Retrieves the Pango::Context used for this layout. More...
void | set_attributes (AttrList& attrs)
| Sets the text attributes for a layout object. More...
AttrList | get_attributes () const
| Gets the attribute list for the layout, if any. More...
void | set_text (const Glib::ustring& text)
| Set the text of the layout. More...
Glib::ustring | get_text () const
| Gets the text in the layout. More...
int | get_character_count () const
| Returns the number of Unicode characters in the the text of layout. More...
void | set_markup (const Glib::ustring& markup)
| Sets the layout text and attribute list from marked-up text (see markup format). More...
void | set_markup (const Glib::ustring& markup, gunichar accel_marker, gunichar& accel_char)
| Sets the layout text and attribute list from marked-up text (see markup format). More...
void | set_font_description (const FontDescription& desc)
| Set the default font description for the layout. More...
void | unset_font_description ()
FontDescription | get_font_description () const
| Gets the font description for the layout, if any. More...
void | set_width (int width)
| Sets the width to which the lines of the Pango::Layout should wrap or ellipsized. More...
int | get_width () const
| Gets the width to which the lines of the Pango::Layout should wrap. More...
void | set_height (int height)
| Sets the height to which the Pango::Layout should be ellipsized at. More...
int | get_height () const
| Gets the height of layout used for ellipsization. More...
void | set_wrap (WrapMode wrap)
| Sets the wrap mode; the wrap mode only has effect if a width is set on the layout with set_width(). More...
WrapMode | get_wrap () const
| Gets the wrap mode for the layout. More...
bool | is_wrapped () const
| Queries whether the layout had to wrap any paragraphs. More...
void | set_indent (int indent)
| Sets the width in Pango units to indent each paragraph. More...
int | get_indent () const
| Gets the paragraph indent width in Pango units. More...
void | set_spacing (int spacing)
| Sets the amount of spacing in Pango unit between the lines of the layout. More...
int | get_spacing () const
| Gets the amount of spacing between the lines of the layout. More...
void | set_justify (bool justify=true)
| Sets whether each complete line should be stretched to fill the entire width of the layout. More...
bool | get_justify () const
| Gets whether each complete line should be stretched to fill the entire width of the layout. More...
bool | get_auto_dir () const
| Gets whether to calculate the bidirectional base direction for the layout according to the contents of the layout. More...
void | set_auto_dir (bool auto_dir=true)
| Sets whether to calculate the bidirectional base direction for the layout according to the contents of the layout; when this flag is on (the default), then paragraphs in layout that begin with strong right-to-left characters (Arabic and Hebrew principally), will have right-to-left layout, paragraphs with letters from other scripts will have left-to-right layout. More...
void | set_alignment (Alignment alignment)
| Sets the alignment for the layout: how partial lines are positioned within the horizontal space available. More...
Alignment | get_alignment () const
| Gets the alignment for the layout: how partial lines are positioned within the horizontal space available. More...
void | set_tabs (TabArray& tabs)
| Sets the tabs to use for layout, overriding the default tabs (by default, tabs are every 8 spaces). More...
TabArray | get_tabs () const
| Get the current Pango::TabArray used by this layout. More...
void | set_single_paragraph_mode (bool setting=true)
| If setting is `true`, do not treat newlines and similar characters as paragraph separators; instead, keep all text in a single paragraph, and display a glyph for paragraph separator characters. More...
bool | get_single_paragraph_mode () const
| Obtains the value set by set_single_paragraph_mode(). More...
void | set_ellipsize (EllipsizeMode ellipsize)
| Sets the type of ellipsization being performed for layout. More...
EllipsizeMode | get_ellipsize () const
| Gets the type of ellipsization being performed for layout. More...
bool | is_ellipsized () const
| Queries whether the layout had to ellipsize any paragraphs. More...
int | get_unknown_glyphs_count () const
| Counts the number unknown glyphs in layout. More...
void | context_changed ()
| Forces recomputation of any state in the Pango::Layout that might depend on the layout's context. More...
guint | get_serial () const
| Returns the current serial number of layout. More...
Glib::ArrayHandle< LogAttr > | get_log_attrs () const
| Retrieve an array of logical attributes for each character in the layout. More...
Rectangle | index_to_pos (int index) const
| Convert from an index within the layout to the onscreen position corresponding to the grapheme at that index, which is represented as rectangle. More...
void | index_to_line_x (int index_, bool trailing, int& line, int& x_pos) const
| Converts from byte index within the layout to line and X position. More...
void | get_cursor_pos (int index, Rectangle& strong_pos, Rectangle& weak_pos) const
| Given an index within a layout, determines the positions that of the strong and weak cursors if the insertion point is at that index. More...
Rectangle | get_cursor_strong_pos (int index) const
| Given an index within the layout, determine the positions that of the strong cursors if the insertion point is at that index. More...
Rectangle | get_cursor_weak_pos (int index) const
| Given an index within the layout, determine the positions that of the weak cursors if the insertion point is at that index. More...
void | move_cursor_visually (bool strong, int old_index, int old_trailing, int direction, int& new_index, int& new_trailing) const
| Computes a new cursor position from an old position and a count of positions to move visually. More...
bool | xy_to_index (int x, int y, int& index, int& trailing) const
| Converts from X and Y position within a layout to the byte index to the character at that logical position. More...
void | get_extents (Rectangle& ink_rect, Rectangle& logical_rect) const
| Compute the logical and ink extents of layout. More...
Rectangle | get_ink_extents () const
| Compute the ink extents of layout. More...
Rectangle | get_logical_extents () const
| Compute the logical extents of layout. More...
void | get_pixel_extents (Rectangle& ink_rect, Rectangle& logical_rect) const
| Compute the logical and ink extents of layout in device units. More...
Rectangle | get_pixel_ink_extents () const
| Compute the ink extents of the layout in device units. More...
Rectangle | get_pixel_logical_extents () const
| Compute the logical extents of the layout in device units. More...
void | get_size (int& width, int& height) const
| Determines the logical width and height of a Pango::Layout in Pango units (device units scaled by Pango::SCALE). More...
void | get_pixel_size (int& width, int& height) const
| Determines the logical width and height of a Pango::Layout in device units. More...
int | get_baseline () const
| Gets the Y position of baseline of the first line in layout. More...
int | get_line_count () const
| Retrieves the count of lines for the layout. More...
Glib::RefPtr< LayoutLine > | get_line (int line)
| Retrieves a particular line from a Pango::Layout. More...
Glib::RefPtr< const LayoutLine > | get_line (int line) const
| Retrieves a particular line from a Pango::Layout. More...
SListHandle_LayoutLine | get_lines ()
| Returns the lines of the layout as a list. More...
SListHandle_ConstLayoutLine | get_lines () const
| Returns the lines of the layout as a list. More...
void | get_iter (LayoutIter& iter)
| Gets an iterator to iterate over the visual extents of the layout. More...
LayoutIter | get_iter ()
| Gets an iterator to iterate over the visual extents of the layout. More...
void | add_to_cairo_context (const Cairo::RefPtr< Cairo::Context >& context)
| Adds the text in this LayoutLine to the current path in the specified Cairo context. More...
void | show_in_cairo_context (const Cairo::RefPtr< Cairo::Context >& context)
| Draws a Layout in the specified Cairo context. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Layout > | create (const Glib::RefPtr< Context >& context)
static Glib::RefPtr< Layout > | create (const Cairo::RefPtr< Cairo::Context >& context)
| Creates a layout object set up to match the current transformation and target surface of the Cairo context. More...

## Protected Member Functions
| Layout (const Glib::RefPtr< Context >& context)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Pango::Layout > | wrap (PangoLayout* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Pango::Layout represents an entire paragraph of text.

It is initialized with a Pango::Context, UTF-8 string and set of attributes for that string. Once that is done, the set of formatted lines can be extracted from the object, the layout can be rendered, and conversion between logical character positions within the layout's text, and the physical position of the resulting glyphs can be made.

## Constructor & Destructor Documentation

Pango::Layout::Layout | ( | Layout&& | src | ) |
| noexcept

Pango::Layout::~Layout | ( |  | ) |
| override noexcept

Pango::Layout::Layout | ( | const Glib::RefPtr< Context >& | context | ) |
| explicit protected

## Member Function Documentation

void Pango::Layout::add_to_cairo_context | ( | const Cairo::RefPtr< Cairo::Context > & | context | ) |

Adds the text in this LayoutLine to the current path in the specified Cairo context.

The origin of the glyphs (the left edge of the line) will be at the current point of the cairo context.

Parameters

  context | A Cairo context.

void Pango::Layout::context_changed | ( |  | ) |

Forces recomputation of any state in the Pango::Layout that might depend on the layout's context.

This function should be called if you make changes to the context subsequent to creating the layout.

Glib::RefPtr<Layout> Pango::Layout::copy | ( |  | ) |

Does a deep copy-by-value of the src layout.

The attribute list, tab array, and text from the original layout are all copied by value.

Returns
  The newly allocated Pango::Layout, with a reference count of one, which should be freed with Glib::object_unref().

static Glib::RefPtr<Layout> Pango::Layout::create | ( | const Glib::RefPtr< Context >& | context | ) |
| static

static Glib::RefPtr<Layout> Pango::Layout::create | ( | const Cairo::RefPtr< Cairo::Context > & | context | ) |
| static

Creates a layout object set up to match the current transformation and target surface of the Cairo context.

This layout can then be used for text measurement with functions like get_size() or drawing with methods like show_in_cairo_contet(). If you change the transformation or target surface for context, you need to call update_from_cairo_context()

This is the most convenient way to use Cairo with Pango. However it is slightly inefficient since it creates a separate Pango Context object for each layout. This might matter in an application that is laying out large amounts of text.

Parameters

  context | A Cairo context.

Returns
  The newly created Pango Layout.

Alignment Pango::Layout::get_alignment | ( |  | ) | const

Gets the alignment for the layout: how partial lines are positioned within the horizontal space available.

Returns
  The alignment.

AttrList Pango::Layout::get_attributes | ( |  | ) | const

Gets the attribute list for the layout, if any.

Returns
  A Pango::AttrList.

bool Pango::Layout::get_auto_dir | ( |  | ) | const

Gets whether to calculate the bidirectional base direction for the layout according to the contents of the layout.

See set_auto_dir().

Since pangomm 1.4:

Returns
  `true` if the bidirectional base direction is computed from the layout's contents, `false` otherwise.

int Pango::Layout::get_baseline | ( |  | ) | const

Gets the Y position of baseline of the first line in layout.

Since pangomm 1.22:

Returns
  Baseline of first line, from top of layout.

int Pango::Layout::get_character_count | ( |  | ) | const

Returns the number of Unicode characters in the the text of layout.

Since pangomm 1.30:

Returns
  The number of Unicode characters in the text of layout.

Glib::RefPtr<Context> Pango::Layout::get_context | ( |  | ) | const

Retrieves the Pango::Context used for this layout.

Returns
  The Pango::Context for the layout. This does not have an additional refcount added, so if you want to keep a copy of this around, you must reference it yourself.

void Pango::Layout::get_cursor_pos | ( | int | index,
|  | Rectangle& | strong_pos,
|  | Rectangle& | weak_pos
| ) |  | const

Given an index within a layout, determines the positions that of the strong and weak cursors if the insertion point is at that index.

The position of each cursor is stored as a zero-width rectangle. The strong cursor location is the location where characters of the directionality equal to the base direction of the layout are inserted. The weak cursor location is the location where characters of the directionality opposite to the base direction of the layout are inserted.

Parameters

  index | The byte index of the cursor.
  strong_pos | Location to store the strong cursor position (may be `nullptr`).
  weak_pos | Location to store the weak cursor position (may be `nullptr`).

Rectangle Pango::Layout::get_cursor_strong_pos | ( | int | index | ) | const

Given an index within the layout, determine the positions that of the strong cursors if the insertion point is at that index.

Parameters

  index | The byte index of the cursor.

Returns
  The strong cursor position.

Rectangle Pango::Layout::get_cursor_weak_pos | ( | int | index | ) | const

Given an index within the layout, determine the positions that of the weak cursors if the insertion point is at that index.

Parameters

  index | The byte index of the cursor.

Returns
  The weak cursor position.

EllipsizeMode Pango::Layout::get_ellipsize | ( |  | ) | const

Gets the type of ellipsization being performed for layout.

See set_ellipsize()

Since pangomm 1.6:

Returns
  The current ellipsization mode for layout.

Use is_ellipsized() to query whether any paragraphs were actually ellipsized.

void Pango::Layout::get_extents | ( | Rectangle& | ink_rect,
|  | Rectangle& | logical_rect
| ) |  | const

Compute the logical and ink extents of layout.

Logical extents are usually what you want for positioning things. The extents are given in layout coordinates; layout coordinates begin at the top left corner of the layout.

Parameters

  ink_rect | Rectangle used to store the extents of the layout as drawn.
  logical_rect | Rectangle used to store the logical extents of the layout.

FontDescription Pango::Layout::get_font_description | ( |  | ) | const

Gets the font description for the layout, if any.

Since pangomm 1.8:

Returns
  A pointer to the layout's font description, or `nullptr` if the font description from the layout's context is inherited. This value is owned by the layout and must not be modified or freed.

int Pango::Layout::get_height | ( |  | ) | const

Gets the height of layout used for ellipsization.

See set_height() for details.

Since pangomm 1.20:

Returns
  The height, in Pango units if positive, or number of lines if negative.

int Pango::Layout::get_indent | ( |  | ) | const

Gets the paragraph indent width in Pango units.

A negative value indicates a hanging indentation.

Returns
  The indent in Pango units.

Rectangle Pango::Layout::get_ink_extents | ( |  | ) | const

Compute the ink extents of layout.

Returns
  The extents of the layout as drawn.

void Pango::Layout::get_iter | ( | LayoutIter& | iter | ) |

Gets an iterator to iterate over the visual extents of the layout.

Parameters

  iter | Location to store the iterator.

Deprecated:
  Use the get_iter() that returns the LayoutIter instead of using an output parameter.

LayoutIter Pango::Layout::get_iter | ( |  | ) |

Gets an iterator to iterate over the visual extents of the layout.

Returns
  The iterator.

Since pangomm 2.28:

bool Pango::Layout::get_justify | ( |  | ) | const

Gets whether each complete line should be stretched to fill the entire width of the layout.

Returns
  The justify.

Glib::RefPtr<LayoutLine> Pango::Layout::get_line | ( | int | line | ) |

Retrieves a particular line from a Pango::Layout.

Use the faster get_line_readonly() if you do not plan to modify the contents of the line (glyphs, glyph widths, etc.).

Parameters

  line | The index of a line, which must be between 0 and `pango_layout_get_line_count(layout) - 1`, inclusive.

Returns
  The requested Pango::LayoutLine, or `nullptr` if the index is out of range. This layout line can be ref'ed and retained, but will become invalid if changes are made to the Pango::Layout.

Glib::RefPtr<const LayoutLine> Pango::Layout::get_line | ( | int | line | ) | const

Retrieves a particular line from a Pango::Layout.

This is a faster alternative to get_line(), but the user is not expected to modify the contents of the line (glyphs, glyph widths, etc.).

Since pangomm 1.16:

Parameters

  line | The index of a line, which must be between 0 and `pango_layout_get_line_count(layout) - 1`, inclusive.

Returns
  The requested Pango::LayoutLine, or `nullptr` if the index is out of range. This layout line can be ref'ed and retained, but will become invalid if changes are made to the Pango::Layout. No changes should be made to the line.

int Pango::Layout::get_line_count | ( |  | ) | const

Retrieves the count of lines for the layout.

Returns
  The line count.

SListHandle_LayoutLine Pango::Layout::get_lines | ( |  | ) |

Returns the lines of the layout as a list.

Use the faster get_lines_readonly() if you do not plan to modify the contents of the lines (glyphs, glyph widths, etc.).

Returns
  A SList containing the lines in the layout. This points to internal data of the Pango::Layout and must be used with care. It will become invalid on any change to the layout's text or properties.

SListHandle_ConstLayoutLine Pango::Layout::get_lines | ( |  | ) | const

Returns the lines of the layout as a list.

This is a faster alternative to get_lines(), but the user is not expected to modify the contents of the lines (glyphs, glyph widths, etc.).

Since pangomm 1.16:

Returns
  A SList containing the lines in the layout. This points to internal data of the Pango::Layout and must be used with care. It will become invalid on any change to the layout's text or properties. No changes should be made to the lines.

Glib::ArrayHandle<LogAttr> Pango::Layout::get_log_attrs | ( |  | ) | const

Retrieve an array of logical attributes for each character in the layout.

Returns
  An array of logical attributes.

Rectangle Pango::Layout::get_logical_extents | ( |  | ) | const

Compute the logical extents of layout.

Returns
  The logical extents of the layout.

void Pango::Layout::get_pixel_extents | ( | Rectangle& | ink_rect,
|  | Rectangle& | logical_rect
| ) |  | const

Compute the logical and ink extents of layout in device units.

See get_extents(); this function just calls get_extents() and then converts the extents to pixels using the Pango::SCALE factor.

Parameters

  ink_rect | Rectangle used to store the extents of the layout as drawn.
  logical_rect | Rectangle used to store the logical extents of the layout.

Rectangle Pango::Layout::get_pixel_ink_extents | ( |  | ) | const

Compute the ink extents of the layout in device units.

Returns
  The extents of the layout as drawn.

Rectangle Pango::Layout::get_pixel_logical_extents | ( |  | ) | const

Compute the logical extents of the layout in device units.

Returns
  The logical extents of the layout.

void Pango::Layout::get_pixel_size | ( | int & | width,
|  | int & | height
| ) |  | const

Determines the logical width and height of a Pango::Layout in device units.

(get_size() returns the width and height scaled by Pango::SCALE.) This is simply a convenience function around get_pixel_extents().

Parameters

  width | Location to store the logical width, or `nullptr`.
  height | Location to store the logical height, or `nullptr`.

guint Pango::Layout::get_serial | ( |  | ) | const

Returns the current serial number of layout.

The serial number is initialized to an small number larger than zero when a new layout is created and is increased whenever the layout is changed using any of the setter functions, or the Pango::Context it uses has changed. The serial may wrap, but will never have the value 0. Since it can wrap, never compare it with "less than", always use "not equals".

This can be used to automatically detect changes to a Pango::Layout, and is useful for example to decide whether a layout needs redrawing. To force the serial to be increased, use context_changed().

Since pangomm 1.32.4:

Returns
  The current serial number of layout.

bool Pango::Layout::get_single_paragraph_mode | ( |  | ) | const

Obtains the value set by set_single_paragraph_mode().

Returns
  `true` if the layout does not break paragraphs at paragraph separator characters, `false` otherwise.

void Pango::Layout::get_size | ( | int & | width,
|  | int & | height
| ) |  | const

Determines the logical width and height of a Pango::Layout in Pango units (device units scaled by Pango::SCALE).

This is simply a convenience function around get_extents().

Parameters

  width | Location to store the logical width, or `nullptr`.
  height | Location to store the logical height, or `nullptr`.

int Pango::Layout::get_spacing | ( |  | ) | const

Gets the amount of spacing between the lines of the layout.

Returns
  The spacing in Pango units.

TabArray Pango::Layout::get_tabs | ( |  | ) | const

Get the current Pango::TabArray used by this layout.

If no Pango::TabArray has been set, then the default tabs are in use and an invalid instance is returned. Default tabs are every 8 spaces.

Returns
  A copy of the tabs for this layout.

Glib::ustring Pango::Layout::get_text | ( |  | ) | const

Gets the text in the layout.

The returned text should not be freed or modified.

Returns
  The text in the layout.

static GType Pango::Layout::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

int Pango::Layout::get_unknown_glyphs_count | ( |  | ) | const

Counts the number unknown glyphs in layout.

That is, zero if glyphs for all characters in the layout text were found, or more than zero otherwise.

This function can be used to determine if there are any fonts available to render all characters in a certain string, or when used in combination with Pango::ATTR_FALLBACK, to check if a certain font supports all the characters in the string.

Since pangomm 1.16:

Returns
  The number of unknown glyphs in layout.

int Pango::Layout::get_width | ( |  | ) | const

Gets the width to which the lines of the Pango::Layout should wrap.

Returns
  The width in Pango units, or -1 if no width set.

WrapMode Pango::Layout::get_wrap | ( |  | ) | const

Gets the wrap mode for the layout.

Use is_wrapped() to query whether any paragraphs were actually wrapped.

Returns
  Active wrap mode.

PangoLayout* Pango::Layout::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const PangoLayout* Pango::Layout::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

PangoLayout* Pango::Layout::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Pango::Layout::index_to_line_x | ( | int | index_,
|  | bool | trailing,
|  | int & | line,
|  | int & | x_pos
| ) |  | const

Converts from byte index within the layout to line and X position.

(X position is measured from the left edge of the line)

Parameters

  index | The byte index of a grapheme within the layout.
  trailing | An integer indicating the edge of the grapheme to retrieve the position of. If > 0, the trailing edge of the grapheme, if 0, the leading of the grapheme.
  line | Location to store resulting line index. (which will between 0 and pango_layout_get_line_count(layout) - 1), or `nullptr`.
  x_pos | Location to store resulting position within line (Pango::SCALE units per device unit), or `nullptr`.

Rectangle Pango::Layout::index_to_pos | ( | int | index | ) | const

Convert from an index within the layout to the onscreen position corresponding to the grapheme at that index, which is represented as rectangle.

Note that x in the returned rectangle is always the leading edge of the grapheme and x + width the trailing edge of the grapheme. If the directionality of the grapheme is right-to-left, then width will be negative.

Parameters

  index | Byte index within layout.

Returns
  The position of the grapheme.

bool Pango::Layout::is_ellipsized | ( |  | ) | const

Queries whether the layout had to ellipsize any paragraphs.

This returns `true` if the ellipsization mode for layout is not Pango::ELLIPSIZE_NONE, a positive width is set on layout, and there are paragraphs exceeding that width that have to be ellipsized.

Since pangomm 1.16:

Returns
  `true` if any paragraphs had to be ellipsized, `false` otherwise.

bool Pango::Layout::is_wrapped | ( |  | ) | const

Queries whether the layout had to wrap any paragraphs.

This returns `true` if a positive width is set on layout, ellipsization mode of layout is set to Pango::ELLIPSIZE_NONE, and there are paragraphs exceeding the layout width that have to be wrapped.

Since pangomm 1.16:

Returns
  `true` if any paragraphs had to be wrapped, `false` otherwise.

void Pango::Layout::move_cursor_visually | ( | bool | strong,
|  | int | old_index,
|  | int | old_trailing,
|  | int | direction,
|  | int & | new_index,
|  | int & | new_trailing
| ) |  | const

Computes a new cursor position from an old position and a count of positions to move visually.

If direction is positive, then the new strong cursor position will be one position to the right of the old cursor position. If direction is negative, then the new strong cursor position will be one position to the left of the old cursor position.

In the presence of bidirectional text, the correspondence between logical and visual order will depend on the direction of the current run, and there may be jumps when the cursor is moved off of the end of a run.

Motion here is in cursor positions, not in characters, so a single call to move_cursor_visually() may move the cursor over multiple characters when multiple characters combine to form a single grapheme.

Parameters

  strong | Whether the moving cursor is the strong cursor or the weak cursor. The strong cursor is the cursor corresponding to text insertion in the base direction for the layout.
  old_index | The byte index of the grapheme for the old index.
  old_trailing | If 0, the cursor was at the leading edge of the grapheme indicated by old_index, if > 0, the cursor was at the trailing edge.
  direction | Direction to move cursor. A negative value indicates motion to the left.
  new_index | Location to store the new cursor byte index. A value of -1 indicates that the cursor has been moved off the beginning of the layout. A value of MAXINT indicates that the cursor has been moved off the end of the layout.
  new_trailing | Number of characters to move forward from the location returned for new_index to get the position where the cursor should be displayed. This allows distinguishing the position at the beginning of one line from the position at the end of the preceding line. new_index is always on the line where the cursor should be displayed.

Layout& Pango::Layout::operator= | ( | Layout&& | src | ) |
| noexcept

void Pango::Layout::set_alignment | ( | Alignment | alignment | ) |

Sets the alignment for the layout: how partial lines are positioned within the horizontal space available.

Parameters

  alignment | The alignment.

void Pango::Layout::set_attributes | ( | AttrList& | attrs | ) |

Sets the text attributes for a layout object.

References attrs, so the caller can unref its reference.

Parameters

  attrs | A Pango::AttrList, can be `nullptr`.

void Pango::Layout::set_auto_dir | ( | bool | auto_dir = `true` | ) |

Sets whether to calculate the bidirectional base direction for the layout according to the contents of the layout; when this flag is on (the default), then paragraphs in layout that begin with strong right-to-left characters (Arabic and Hebrew principally), will have right-to-left layout, paragraphs with letters from other scripts will have left-to-right layout.

Paragraphs with only neutral characters get their direction from the surrounding paragraphs.

When `false`, the choice between left-to-right and right-to-left layout is done according to the base direction of the layout's Pango::Context. (See Pango::Context::set_base_dir()).

When the auto-computed direction of a paragraph differs from the base direction of the context, the interpretation of Pango::ALIGN_LEFT and Pango::ALIGN_RIGHT are swapped.

Since pangomm 1.4:

Parameters

  auto_dir | If `true`, compute the bidirectional base direction from the layout's contents.

void Pango::Layout::set_ellipsize | ( | EllipsizeMode | ellipsize | ) |

Sets the type of ellipsization being performed for layout.

Depending on the ellipsization mode ellipsize text is removed from the start, middle, or end of text so they fit within the width and height of layout set with set_width() and set_height().

If the layout contains characters such as newlines that force it to be layed out in multiple paragraphs, then whether each paragraph is ellipsized separately or the entire layout is ellipsized as a whole depends on the set height of the layout. See set_height() for details.

Since pangomm 1.6:

Parameters

  ellipsize | The new ellipsization mode for layout.

void Pango::Layout::set_font_description | ( | const FontDescription& | desc | ) |

Set the default font description for the layout.

If no font description is set on the layout, the font description from the layout's context is used.

Parameters

  desc | The new pango font description.

void Pango::Layout::set_height | ( | int | height | ) |

Sets the height to which the Pango::Layout should be ellipsized at.

There are two different behaviors, based on whether height is positive or negative.

If height is positive, it will be the maximum height of the layout. Only lines would be shown that would fit, and if there is any text omitted, an ellipsis added. At least one line is included in each paragraph regardless of how small the height value is. A value of zero will render exactly one line for the entire layout.

If height is negative, it will be the (negative of) maximum number of lines per paragraph. That is, the total number of lines shown may well be more than this value if the layout contains multiple paragraphs of text. The default value of -1 means that first line of each paragraph is ellipsized. This behvaior may be changed in the future to act per layout instead of per paragraph. File a bug against pango at http://bugzilla.gnome.org/ if your code relies on this behavior.

Height setting only has effect if a positive width is set on layout and ellipsization mode of layout is not Pango::ELLIPSIZE_NONE. The behavior is undefined if a height other than -1 is set and ellipsization mode is set to Pango::ELLIPSIZE_NONE, and may change in the future.

Since pangomm 1.20:

Parameters

  height | The desired height of the layout in Pango units if positive, or desired number of lines if negative.

void Pango::Layout::set_indent | ( | int | indent | ) |

Sets the width in Pango units to indent each paragraph.

A negative value of indent will produce a hanging indentation. That is, the first line will have the full width, and subsequent lines will be indented by the absolute value of indent.

The indent setting is ignored if layout alignment is set to Pango::ALIGN_CENTER.

Parameters

  indent | The amount by which to indent.

void Pango::Layout::set_justify | ( | bool | justify = `true` | ) |

Sets whether each complete line should be stretched to fill the entire width of the layout.

This stretching is typically done by adding whitespace, but for some scripts (such as Arabic), the justification may be done in more complex ways, like extending the characters.

Note that this setting is not implemented and so is ignored in Pango older than 1.18.

Parameters

  justify | Whether the lines in the layout should be justified.

void Pango::Layout::set_markup | ( | const Glib::ustring & | markup | ) |

Sets the layout text and attribute list from marked-up text (see markup format).

Replaces the current text and attribute list.

Parameters

  markup | Some marked-up text.

void Pango::Layout::set_markup | ( | const Glib::ustring & | markup,
|  | gunichar | accel_marker,
|  | gunichar & | accel_char
| ) |  |

Sets the layout text and attribute list from marked-up text (see markup format).

Replaces the current text and attribute list.

If accel_marker is nonzero, the given character will mark the character following it as an accelerator. For example, the accel marker might be an ampersand or underscore. All characters marked as an accelerator will receive a Pango::UNDERLINE_LOW attribute, and the first character so marked will be returned in accel_char. Two accel_marker characters following each other produce a single literal accel_marker character.

Parameters

  markup | Some marked-up text.
  accel_marker | Marker for accelerators in the text.
  accel_char | Return location for any located accelerators.

void Pango::Layout::set_single_paragraph_mode | ( | bool | setting = `true` | ) |

If setting is `true`, do not treat newlines and similar characters as paragraph separators; instead, keep all text in a single paragraph, and display a glyph for paragraph separator characters.

Used when you want to allow editing of newlines on a single text line.

Parameters

  setting | New setting.

void Pango::Layout::set_spacing | ( | int | spacing | ) |

Sets the amount of spacing in Pango unit between the lines of the layout.

Parameters

  spacing | The amount of spacing.

void Pango::Layout::set_tabs | ( | TabArray& | tabs | ) |

Sets the tabs to use for layout, overriding the default tabs (by default, tabs are every 8 spaces).

If tabs is `nullptr`, the default tabs are reinstated. tabs is copied into the layout; you must free your copy of tabs yourself.

Parameters

  tabs | A Pango::TabArray, or `nullptr`.

void Pango::Layout::set_text | ( | const Glib::ustring & | text | ) |

Set the text of the layout.

Parameters

  text | The text for the layout.

void Pango::Layout::set_width | ( | int | width | ) |

Sets the width to which the lines of the Pango::Layout should wrap or ellipsized.

The default value is -1: no width set.

Parameters

  width | The desired width in Pango units, or -1 to indicate that no wrapping or ellipsization should be performed.

void Pango::Layout::set_wrap | ( | WrapMode | wrap | ) |

Sets the wrap mode; the wrap mode only has effect if a width is set on the layout with set_width().

To turn off wrapping, set the width to -1.

Parameters

  wrap | The wrap mode.

void Pango::Layout::show_in_cairo_context | ( | const Cairo::RefPtr< Cairo::Context > & | context | ) |

Draws a Layout in the specified Cairo context.

The top-left corner of the Layout will be drawn at the current point of the cairo context.

Parameters

  context | A Cairo context.

Since pangomm 2.16:

void Pango::Layout::unset_font_description | ( |  | ) |

void Pango::Layout::update_from_cairo_context | ( | const Cairo::RefPtr< Cairo::Context > & | context | ) |

Updates the private Pango Context of a Pango Layout created with create(const Cairo::RefPtr<Cairo::Context>&) to match the current transformation and target surface of a Cairo Context.

Parameters

  context | A Cairo context.

bool Pango::Layout::xy_to_index | ( | int | x,
|  | int | y,
|  | int & | index,
|  | int & | trailing
| ) |  | const

Converts from X and Y position within a layout to the byte index to the character at that logical position.

If the Y position is not inside the layout, the closest position is chosen (the position will be clamped inside the layout). If the X position is not within the layout, then the start or the end of the line is chosen as described for Pango::LayoutLine::x_to_index(). If either the X or Y positions were not inside the layout, then the function returns `false`; on an exact hit, it returns `true`.

Parameters

  x | The X offset (in Pango units) from the left edge of the layout.
  y | The Y offset (in Pango units) from the top edge of the layout.
  index | Location to store calculated byte index.
  trailing | Location to store a integer indicating where in the grapheme the user clicked. It will either be zero, or the number of characters in the grapheme. 0 represents the leading edge of the grapheme.

Returns
  `true` if the coordinates were inside text, `false` otherwise.

## Friends And Related Function Documentation

Glib::RefPtr< Pango::Layout > wrap | ( | PangoLayout * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.